
%define		dataver	1.32b3-1
%define		snap	20201018
%define		rel	1
Summary:	Quake3 for Linux
Summary(de.UTF-8):	Quake3 für Linux
Summary(pl.UTF-8):	Quake3 dla Linuksa
Name:		quake3
Version:	1.36
Release:	0.%{snap}.%{rel}
License:	GPL v2
Group:		X11/Applications/Games
# svn export svn://svn.icculus.org/quake3/branches/1.36 quake3
Source0:	%{name}-%{snap}.tar.bz2
# Source0-md5:	2c888117c5ba3456f06e849f46bccba1
Source2:	q3ded.init
Source3:	q3ded.sysconfig
Source4:	%{name}.desktop
Source5:	%{name}-smp.desktop
Patch0:		%{name}-QUAKELIBDIR.patch
Patch1:		%{name}-alpha.patch
Patch2:		x32.patch
URL:		http://ioquake3.org/
BuildRequires:	OpenAL-devel
BuildRequires:	OpenGL-GLU-devel
BuildRequires:	OpenGL-devel
BuildRequires:	SDL2-devel
BuildRequires:	curl-devel
BuildRequires:	freetype-devel >= 2
BuildRequires:	libjpeg-devel
BuildRequires:	libogg-devel
BuildRequires:	libvorbis-devel
BuildRequires:	opus-devel
BuildRequires:	opusfile-devel
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.268
BuildRequires:	which
BuildRequires:	zlib-devel
Requires:	%{name}-common = %{version}-%{release}
Requires:	OpenGL
Requires:	quake3-data >= %{dataver}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

# source has been fixed to work without those
%define		filterout_c	-fwrapv -fno-strict-aliasing -fsigned-char

%define		specflags	-ffast-math -funroll-loops -fomit-frame-pointer
%define		x86_flags	-falign-loops=2 -falign-jumps=2 -falign-functions=2 -fstrength-reduce
%define		specflags_ia32	%{x86_flags}
%define		specflags_x86_64 %{x86_flags}
%define		specflags_amd64	%{x86_flags}
%define		specflags_ia32e	%{x86_flags}
%define		_noautoreqdep	libGL.so.1 libGLU.so.1

%description
Quake 3 for Linux.

%description -l de.UTF-8
Quake 3 für Linux.

%description -l pl.UTF-8
Quake 3 dla Linuksa.

%package server
Summary:	Quake3 server
Summary(de.UTF-8):	Quake3 Server
Summary(pl.UTF-8):	Serwer Quake3
Group:		X11/Applications/Games
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(postun):	/usr/sbin/userdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires(triggerpostun):	/usr/sbin/usermod
Requires:	%{name}-common = %{version}-%{release}
Requires:	psmisc
Requires:	rc-scripts
Requires:	screen
Provides:	group(quake3)
Provides:	user(quake3)

%description server
Quake3 server.

%description server -l de.UTF-8
Quake3 Server.

%description server -l pl.UTF-8
Serwer Quake3.

%package smp
Summary:	Quake3 for SMP
Summary(de.UTF-8):	Quake3 für SMP
Summary(pl.UTF-8):	Quake3 dla SMP
Group:		X11/Applications/Games
Requires:	%{name}-common = %{version}-%{release}
Requires:	quake3-data >= %{dataver}

%description smp
Quake3 for multi processor machine.

%description smp -l de.UTF-8
Quake3 für Multiprocessor Rechner.

%description smp -l pl.UTF-8
Quake3 dla maszyny wieloprocesorowej.

%package common
Summary:	Common files for Quake3
Summary(de.UTF-8):	Gemeinsame Dateien für Quake3
Summary(pl.UTF-8):	Pliki wspólne dla Quake3
Group:		X11/Applications/Games
Requires(triggerpostun):	/usr/sbin/groupdel
Requires(triggerpostun):	/usr/sbin/userdel
Obsoletes:	quake3-single

%description common
Common files for Quake3 server and player game.

%description common -l de.UTF-8
Gemeinsame Dateien für den Quake3 Server und das Spiel.

%description common -l pl.UTF-8
Pliki wspólne Quake3 dla serwera i trybu gracza.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1
%ifarch x32
%patch2 -p1
%endif

%build
cat << 'EOF' > Makefile.local
BUILD_STANDALONE= 0
BUILD_CLIENT	= 1
# smp broken
BUILD_CLIENT_SMP= 0
BUILD_SERVER	= 1
BUILD_GAME_SO	= 1
BUILD_GAME_QVM	= 0
BUILD_MISSIONPACK= 1
USE_OPENAL	= 1
USE_OPENAL_DLOPEN = 0
USE_CURL	= 1
USE_CURL_DLOPEN = 0
USE_CODEC_VORBIS = 1
USE_FREETYPE = 1
USE_MUMBLE	= 1
USE_VOIP	= 1
USE_INTERNAL_LIBS = 0
GENERATE_DEPENDENCIES = 0

DEFAULT_BASEDIR = %{_datadir}/games/%{name}

override OPTIMIZE = %{rpmcflags} \
	-DQUAKELIBDIR=\"%{_libdir}/%{name}\"

# vim spec bug: "

override CC = %{__cc}
override LDFLAGS = %{rpmldflags}
override BR = rel

EOF

%{__make} V=1 release

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/etc/{rc.d/init.d,sysconfig} \
	$RPM_BUILD_ROOT{%{_bindir},%{_datadir}/games/%{name}/baseq3} \
	$RPM_BUILD_ROOT%{_libdir}/%{name}/{baseq3,missionpack} \
	$RPM_BUILD_ROOT{%{_pixmapsdir},%{_desktopdir}} \
	$RPM_BUILD_ROOT/var/games/quake3

install rel/ioquake3.* $RPM_BUILD_ROOT%{_bindir}/%{name}
#install rel/ioquake3-smp.* $RPM_BUILD_ROOT%{_bindir}/%{name}-smp
install rel/ioq3ded.* $RPM_BUILD_ROOT%{_bindir}/q3ded

install rel/renderer*.so $RPM_BUILD_ROOT%{_libdir}/%{name}

install rel/baseq3/*.so $RPM_BUILD_ROOT%{_libdir}/%{name}/baseq3
install rel/missionpack/*.so $RPM_BUILD_ROOT%{_libdir}/%{name}/missionpack

install %{SOURCE2} $RPM_BUILD_ROOT/etc/rc.d/init.d/q3ded
install %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/q3ded
install misc/%{name}.svg $RPM_BUILD_ROOT%{_pixmapsdir}
install %{SOURCE4} $RPM_BUILD_ROOT%{_desktopdir}/quake3.desktop
install %{SOURCE5} $RPM_BUILD_ROOT%{_desktopdir}/quake3-smp.desktop

%clean
rm -rf $RPM_BUILD_ROOT

%post common
if [ "$1" = "1" ]; then
	echo ""
	echo "You need to copy pak0.pk3 from your Quake3 CD into %{_datadir}/games/%{name}/baseq3/."
	echo "Or if you have got a Windows installation of Q3 make a symlink to save space."
	echo "You may place it in ~/.q3a/baseq3/ but you will have to put all pak files there (or make symlinks)."
	echo ""
fi

%pre server
%groupadd -P %{name}-server -g 38 quake3
%useradd -P %{name}-server -u 124 -d /var/games/quake3 -s /bin/sh -c "Quake ]|[ Arena" -g quake3 quake3

%post server
/sbin/chkconfig --add q3ded
%service q3ded restart "Quake3 server"

%preun server
if [ "$1" = "0" ]; then
	%service q3ded stop
	/sbin/chkconfig --del q3ded
fi

%postun server
if [ "$1" = "0" ]; then
	%userremove quake3
	%groupremove quake3
fi

%triggerpostun server -- %{name}-server < 1.33
# server will fail because of lack of pak0.pk3
%service q3ded stop
if [ "`getent passwd quake3 | cut -d: -f6`" = "/opt/quake3" ]; then
	/usr/sbin/usermod -d /var/games/quake3 -s /bin/sh quake3
fi

%triggerpostun common -- %{name}-common < 1.33
if [ ! -f %{_datadir}/games/%{name}/baseq3/pak0.pk3 ]; then
	# Better don't link/move automatically, /opt may be on other partition than /usr
	echo ""
	echo "Quake 3 data location has changed, link or move pak0.pk3 to %{_datadir}/games/%{name}/baseq3/."
	echo ""
fi

if [ "$1" = "0" ]; then
	%userremove quake3
	%groupremove quake3
fi

%files
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/quake3
%{_desktopdir}/quake3.desktop
%attr(755,root,root) %{_libdir}/%{name}/renderer*.so

%files common
%defattr(644,root,root,755)
%doc CONTRIBUTING.md id-readme.txt README.md SECURITY.md ChangeLog TODO
%dir %{_datadir}/games/%{name}
%dir %{_datadir}/games/%{name}/baseq3
%{_pixmapsdir}/quake3.svg
%dir %{_libdir}/%{name}
%dir %{_libdir}/%{name}/baseq3
%dir %{_libdir}/%{name}/missionpack
%attr(755,root,root) %{_libdir}/%{name}/baseq3/*.so
%attr(755,root,root) %{_libdir}/%{name}/missionpack/*.so

%files server
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/q3ded
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/q3ded
%attr(755,root,root) %{_bindir}/q3ded
%attr(750,quake3,quake3) /var/games/quake3

%if 0
%files smp
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/quake3-smp
%{_desktopdir}/quake3-smp.desktop
%endif
%changelog
* Fri Oct 23 2020 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/quake3.git;a=log;h=master

* Wed Oct 21 2020 Jan Palus <atler@pld-linux.org> b2ff175
- enable verbose build

* Sun Oct 18 2020 Jan Palus <atler@pld-linux.org> 3ef1682
- updated snap to 20201018

* Fri Nov 08 2019 Jan Rękorajski <baggins@pld-linux.org> dcbf90e
- typo

* Fri Nov 08 2019 Jan Rękorajski <baggins@pld-linux.org> d450e06
- fix build on x32

* Mon Aug 26 2019 Jan Palus <atler@pld-linux.org> bde92c2
- updated snap to 20190729

* Sat May 02 2015 Jan Rękorajski <baggins@pld-linux.org> 867ee55
- x32 rebuild
- release 5 (by relup.sh)

* Wed Mar 09 2011 Elan Ruusamäe <glen@pld-linux.org> 23071e2
- Linux caps

* Wed May 12 2010 Jan Rękorajski <baggins@pld-linux.org> fe011c6
- rel 4
- fixed patch

* Wed May 12 2010 Jan Rękorajski <baggins@pld-linux.org> a9522b7
- rel 3
- fix strcpy abuse causing bots not working on 64bit intel cpus with recent glibc
  (see: https://bugzilla.icculus.org/show_bug.cgi?id=4331)

* Sat Nov 28 2009 sparky <sparky@pld-linux.org> 6121ffe
- BR: OpenGL-GLU-devel, pkgconfig, which

* Fri Aug 14 2009 arvenil <arvenil@pld-linux.org> a709a06
- release 2 (rebuild with OpenAL)

* Thu Apr 30 2009 Arkadiusz Miśkiewicz <arekm@maven.pl> 55e78a3
- up to 1.36 20090430

* Sat Feb 28 2009 sparky <sparky@pld-linux.org> 842fa25
- Group: X11/Applications/Games

* Tue Jan 27 2009 Elan Ruusamäe <glen@pld-linux.org> 1faea7f
- avoid dep loops (-common doesn't require -data now)

* Mon Nov 10 2008 sparky <sparky@pld-linux.org> 7d3050c
- BR: curl-devel

* Mon Nov 10 2008 sparky <sparky@pld-linux.org> 11ffbd2
- included in latest snapshot

* Mon Nov 10 2008 sparky <sparky@pld-linux.org> 07b29be
- up to 20081110 snap

* Fri Oct 24 2008 sparky <sparky@pld-linux.org> dea2518
- fixed LDFLAGS

* Fri Oct 24 2008 sparky <sparky@pld-linux.org> c16d1c6
- separate LDFLAGS and LIBS
  http://bugzilla.icculus.org/show_bug.cgi?id=3813

* Fri Oct 24 2008 sparky <sparky@pld-linux.org> f6be443
- one more fix

